<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Function</title>
</head>

<body>
  <script>
    // --------------------------------------------
    // ----- Ülesanne 1
    // --------------------------------------------
    // Kirjuta funktsioon, mis võtab sisendparameetrina toote hinna ja lisab sellele
    // käibemaksu 20%.
    // Kasuta klassikalist süntaksit.

    function addVat(price, vatRate = 1.2) {
      // const vatRate = 1.2
      return price * vatRate
    }

    console.log(addVat(10, 1.22))

    // --------------------------------------------
    // ----- Ülesanne 2
    // --------------------------------------------
    // Kirjuta funktsioon, mis võtab sisendparameetrina toote täishinna ja eemaldab sellelt
    // käibemaksu 20%.
    // Kasuta noolefunktsiooni süntaksit.

    const removeVat = (fullPrice, vatRate = 1.2) => {
      return fullPrice / vatRate
    }

    console.log(removeVat(12))


    // --------------------------------------------
    // ----- Ülesanne 3
    // --------------------------------------------
    // Kirjuta funktsioon, mis võtab sisendparameetrina toote täishinna ja eemaldab sellelt
    // käibemaksu 20%.
    // Kasuta noolefunktsiooni süntaksit.

    // --------------------------------------------
    // ----- Ülesanne 4
    // --------------------------------------------
    // Kirjuta funktsioon, mis võtab sisendparameetrina aastaarvu ja ütleb, kas tegemist on liht- või liitaastaga.
    // Kui liigaasta, siis tagasta väärtus true, vastasel juhul false.
    // Funktsiooni stiil vali ise.
    //
    // Aasta on liigaasta siis...
    // ... kui see jagub neljaga ja samal ajal ei jagu 100-ga
    // ... või kui see jagub 400-ga
    // Vihje: Kuidas tuvastada, kas arv jagub millegi teisega? Selleks on % operaator (jäägiga jagamine).
    // 4 % 2 annab tulemuseks 0 (jääki pole)
    // 5 % 2 annab tulemuseks 1 (jääk 1)

    // function isLeapYear(year) {
    //   if (year % 4 === 0 && year % 100 > 0 || year % 400 === 0) {
    //     return true
    //   } else {
    //     return false
    //   }
    // }

    // function isLeapYear(year) {
    //   return year % 4 === 0 && year % 100 > 0 || year % 400 === 0
    // }

    // const isLeapYear = function(year) {
    //   return year % 4 === 0 && year % 100 > 0 || year % 400 === 0
    // }

    const isLeapYear = year => year % 4 === 0 && year % 100 > 0 || year % 400 === 0

    console.log(2023, isLeapYear(2023))
    console.log(2024, isLeapYear(2024))
    console.log(2000, isLeapYear(2000))
    console.log(1900, isLeapYear(1900))

    function isCurrentYearLeapYear() {
      let currentTime = new Date()
      let currentYear = currentTime.getFullYear()
      return isLeapYear(currentYear)
    }

    console.log('Kas praegune aasta on liigaasta?', isCurrentYearLeapYear())

    // class MyCustomClass{
    //   myName = 'Marek'
    // }

    // let marek = new MyCustomClass()

    // --------------------------------------------
    // ----- Ülesanne 5
    // --------------------------------------------
    // Kirjuta funktsioon, mis võtab sisendparameetrina aasta ja kuu ning tagastab antud aasta ja kuu viimase kuupäeva.
    // Näiteks: getLastDayOfMonth(2020, 2) tagastab 29

    // switch või if-else-if-else

    // function getLastDayOfMonth(year, month) {
    //   switch (month) {
    //     case 1:
    //     case 3:
    //     case 5:
    //     case 7:
    //     case 8:
    //     case 10:
    //     case 12:
    //       return 31
    //     case 2:
    //       if (isLeapYear(year)) {
    //         return 29
    //       } else {
    //         return 28
    //       }
    //     case 4:
    //     case 6:
    //     case 9:
    //     case 11:
    //       return 30
    //     default:
    //       console.error('Vigased sisendparameetrid!')
    //   }
    // }

    function getLastDayOfMonth(year, month) {
      // if (month == 1 || month == 3 || month == 5 || month == 7 || month == 8 || month == 10 || month == 12) {
      if ([4, 6, 9, 11].includes(month)) {
        return 30
      } else if (month == 2) {
        if (isLeapYear(year)) {
          return 29
        } else {
          return 28
        }
      } else {
        return 31
      }
    }

    console.log(getLastDayOfMonth(2020, 7))



    // --------------------------------------------
    // ----- Ülesanne 6 (braintwist)
    // --------------------------------------------
    // Kirjuta funktsioon, mis töötaks nii:
    // sumNumbers(5, 6) tagastab 11
    // sumNumbers(5)(6) tagastab samuti 11
    // Vihje: funktsiooni parameeter võib olla ka funktsioon

    // --------------------------------------------
    // ----- Ülesanne 7
    // --------------------------------------------
    // Kirjuta funktsioon, mis ütleb, kas selle isikukoodiga inimesel on täna sünnipäev

    function filterByGender(persons, gender) {
      const selectedPersons = []
      for (const p of persons) {
        if (deriveGender(p.pin) === gender) {
          selectedPersons.push(p)
        }
      }
      return selectedPersons
    }

    function deriveGender(pin) { // "51109237689"
      const firstDigit = parseInt(pin.substr(0, 1))
      if (firstDigit % 2 == 0) {
        return 'F'
      } else {
        return 'M'
      }
    }

    function getPersonsHavingBirthdayToday(persons) {
      const birthdayChildren = []
      for (const p of persons) {
        if (isBirthdayToday(p.pin)) {
          birthdayChildren.push(p)
        }
      }
      return birthdayChildren
    }

    function isBirthdayToday(pin) {
      const birthMonth = parseInt(pin.substr(3, 2))
      const birthDay = parseInt(pin.substr(5, 2))

      // Mis päev täna on?
      const today = new Date()
      const currentMonth = today.getMonth() + 1
      const currentDay = today.getDate()

      if (birthMonth === currentMonth && birthDay === currentDay) {
        return true
      } else {
        return false
      }
    }

    const personList = [
      { firstName: "Teet", lastName: "Tuisk", pin: "38106193461" },
      { firstName: "Priit", lastName: "Kask", pin: "38706087892" },
      { firstName: "Kati", lastName: "Kuusk", pin: "49106083461" },
      { firstName: "Triinu", lastName: "Tamm", pin: "60606089854" },
      { firstName: "Mati", lastName: "Maasikas", pin: "51109237689" }
    ]

    console.log('Naised', filterByGender(personList, 'F'))
    console.log('Mehed', filterByGender(personList, 'M'))
    console.log('Tänased sünnipäevalapsed', getPersonsHavingBirthdayToday(personList))

  </script>
</body>

</html>